org.h2.expression.condition

## Class ConditionAndOr

- java.lang.Object
- - org.h2.expression.Expression
  - - org.h2.expression.condition.ConditionAndOr

All Implemented Interfaces:
  HasSQL, Typed

    public class ConditionAndOr
    extends Expression

An 'and' or 'or' condition as in WHERE ID=1 AND NAME=?

### Field Summary

Fields
`static int` `AND` The AND condition type as in ID=1 AND NAME='Hello'.
`static int` `OR` The OR condition type as in ID=1 OR NAME='Hello'.

### Fields inherited from class org.h2.expression.Expression

`AUTO_PARENTHESES, MAP_IN_AGGREGATE, MAP_IN_WINDOW, MAP_INITIAL, WITH_PARENTHESES, WITHOUT_PARENTHESES`

### Fields inherited from interface org.h2.util.HasSQL

`ADD_PLAN_INFORMATION, DEFAULT_SQL_FLAGS, NO_CASTS, QUOTE_ONLY_WHEN_REQUIRED, REPLACE_LOBS_FOR_TRACE, TRACE_SQL_FLAGS`

### Constructor Summary

Constructors
Constructor and Description
`ConditionAndOr(int andOrType, Expression left, Expression right)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addFilterConditions(TableFilter filter)` Add conditions to a table filter if they can be evaluated.
`void` `createIndexConditions(SessionLocal session, TableFilter filter)` Create index conditions if possible and attach them to the table filter.
`int` `getCost()` Estimate the cost to process the expression.
`Expression` `getNotIfPossible(SessionLocal session)` If it is possible, return the negated expression.
`Expression` `getSubexpression(int index)` Returns subexpression with specified index.
`int` `getSubexpressionCount()` Returns count of subexpressions.
`TypeInfo` `getType()` Returns the data type.
`java.lang.StringBuilder` `getUnenclosedSQL(java.lang.StringBuilder builder, int sqlFlags)` Get the SQL statement of this expression.
`Value` `getValue(SessionLocal session)` Return the resulting value for the current row.
`boolean` `isEverything(ExpressionVisitor visitor)` Check if this expression and all sub-expressions can fulfill a criteria.
`void` `mapColumns(ColumnResolver resolver, int level, int state)` Map the columns of the resolver to expression columns.
`boolean` `needParentheses()` Returns whether this expressions needs to be wrapped in parentheses when it is used as an argument of other expressions.
`Expression` `optimize(SessionLocal session)` Try to optimize the expression.
`void` `setEvaluatable(TableFilter tableFilter, boolean b)` Tell the expression columns whether the table filter can return values now.
`void` `updateAggregate(SessionLocal session, int stage)` Update an aggregate value.

### Methods inherited from class org.h2.expression.Expression

`getAlias, getBooleanValue, getColumnName, getColumnNameForView, getEnclosedSQL, getNonAliasExpression, getNullable, getSchemaName, getSQL, getSQL, getSQL, getSQL, getTableAlias, getTableName, getWhenSQL, getWhenValue, isConstant, isIdentity, isNullConstant, isValueSet, isWhenConditionOperand, optimizeCondition, toString, writeExpressions, writeExpressions`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.h2.util.HasSQL

`getTraceSQL`

### Field Detail

#### AND

    public static final int AND

The AND condition type as in ID=1 AND NAME='Hello'.

See Also:
  Constant Field Values

#### OR

    public static final int OR

The OR condition type as in ID=1 OR NAME='Hello'.

See Also:
  Constant Field Values

### Constructor Detail

#### ConditionAndOr

    public ConditionAndOr(int andOrType,
                          Expression left,
                          Expression right)

### Method Detail

#### needParentheses

    public boolean needParentheses()

Description copied from class: `Expression`
Returns whether this expressions needs to be wrapped in parentheses when it is used as an argument of other expressions.

Overrides:
  `needParentheses` in class `Expression`
Returns:
  `true` if it is

#### getUnenclosedSQL

    public java.lang.StringBuilder getUnenclosedSQL(java.lang.StringBuilder builder,
                                                    int sqlFlags)

Description copied from class: `Expression`
Get the SQL statement of this expression. This may not always be the original SQL statement, especially after optimization. Enclosing '(' and ')' are never appended.

Specified by:
  `getUnenclosedSQL` in class `Expression`
Parameters:
  `builder` - string builder
  `sqlFlags` - formatting flags
Returns:
  the specified string builder

#### createIndexConditions

    public void createIndexConditions(SessionLocal session,
                                      TableFilter filter)

Description copied from class: `Expression`
Create index conditions if possible and attach them to the table filter.

Overrides:
  `createIndexConditions` in class `Expression`
Parameters:
  `session` - the session
  `filter` - the table filter

#### getNotIfPossible

    public Expression getNotIfPossible(SessionLocal session)

Description copied from class: `Expression`
If it is possible, return the negated expression. This is used to optimize NOT expressions: NOT ID>10 can be converted to ID<=10. Returns null if negating is not possible.

Overrides:
  `getNotIfPossible` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the negated expression, or null

#### getValue

    public Value getValue(SessionLocal session)

Description copied from class: `Expression`
Return the resulting value for the current row.

Specified by:
  `getValue` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the result

#### optimize

    public Expression optimize(SessionLocal session)

Description copied from class: `Expression`
Try to optimize the expression.

Specified by:
  `optimize` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the optimized expression

#### addFilterConditions

    public void addFilterConditions(TableFilter filter)

Description copied from class: `Expression`
Add conditions to a table filter if they can be evaluated.

Overrides:
  `addFilterConditions` in class `Expression`
Parameters:
  `filter` - the table filter

#### mapColumns

    public void mapColumns(ColumnResolver resolver,
                           int level,
                           int state)

Description copied from class: `Expression`
Map the columns of the resolver to expression columns.

Specified by:
  `mapColumns` in class `Expression`
Parameters:
  `resolver` - the column resolver
  `level` - the subquery nesting level
  `state` - current state for nesting checks, initial value is `Expression.MAP_INITIAL`

#### setEvaluatable

    public void setEvaluatable(TableFilter tableFilter,
                               boolean b)

Description copied from class: `Expression`
Tell the expression columns whether the table filter can return values now. This is used when optimizing the query.

Specified by:
  `setEvaluatable` in class `Expression`
Parameters:
  `tableFilter` - the table filter
  `b` - true if the table filter can return value

#### updateAggregate

    public void updateAggregate(SessionLocal session,
                                int stage)

Description copied from class: `Expression`
Update an aggregate value. This method is called at statement execution time. It is usually called once for each row, but if the expression is used multiple times (for example in the column list, and as part of the HAVING expression) it is called multiple times - the row counter needs to be used to make sure the internal state is only updated once.

Specified by:
  `updateAggregate` in class `Expression`
Parameters:
  `session` - the session
  `stage` - select stage

#### isEverything

    public boolean isEverything(ExpressionVisitor visitor)

Description copied from class: `Expression`
Check if this expression and all sub-expressions can fulfill a criteria. If any part returns false, the result is false.

Specified by:
  `isEverything` in class `Expression`
Parameters:
  `visitor` - the visitor
Returns:
  if the criteria can be fulfilled

#### getCost

    public int getCost()

Description copied from class: `Expression`
Estimate the cost to process the expression. Used when optimizing the query, to calculate the query plan with the lowest estimated cost.

Specified by:
  `getCost` in class `Expression`
Returns:
  the estimated cost

#### getSubexpressionCount

    public int getSubexpressionCount()

Description copied from class: `Expression`
Returns count of subexpressions.

Overrides:
  `getSubexpressionCount` in class `Expression`
Returns:
  count of subexpressions

#### getSubexpression

    public Expression getSubexpression(int index)

Description copied from class: `Expression`
Returns subexpression with specified index.

Overrides:
  `getSubexpression` in class `Expression`
Parameters:
  `index` - 0-based index
Returns:
  subexpression with specified index, may be null

#### getType

    public TypeInfo getType()

Description copied from class: `Expression`
Returns the data type. The data type may be unknown before the optimization phase.

Specified by:
  `getType` in interface `Typed`
Specified by:
  `getType` in class `Expression`
Returns:
  the data type